	org	60000

; MJSOFT Speed Tape Operating System version 3.00
; Configuration Maker
; (c) 1991 MJSoft System Software
; Martin Mares & Tomas Zikmund

first	jp	error

modat	equ	32768	; Module position
mlmax	equ	16384	; Maximal module length
stosat	equ	32768	; STOS starting address
versionid	equ	30h

; Main menu loop

main	call	cls
	call	diw
	ld	hl,22561
	ld	bc,1e01h
	ld	a,16+7
	call	attr
	ld	hl,22625
	ld	bc,1e02h
	ld	a,48+64
	call	attr
	ld	hl,22720
	ld	bc,2001h
	ld	a,56
	call	attr
	ld	ix,maintx
	call	write
	ld	hl,cname
	ld	bc,16
	call	prstr
	ld	hl,mmtab
	call	funct
	jr	main

; Number request prefix

empty	db	0,7
	dm	'#$'

; Main menu text

maintx	db	1,1
	dm	'STOS 3.00  Configuration Maker'
	db	1,3
	db	127
	dm	' 1991  MJSoft System Software'
	db	2,4
	dm	'Martin Mares & Tomas Zikmund'
	db	0,7
	dm	'Load New Standard Info Make Quit'
	db	0,6
	dm	'Config. name: $'
	db	'$'

; Main menu function table

mmtab	db	's'
	dw	std
	db	'n'
	dw	new
	db	'i'
	dw	info
	db	'q'
	dw	quit
	db	'm'
	dw	make
	db	'l'
	dw	load
	db	255

; Clear the screen

cls	ld	hl,16384
	ld	bc,2047
	xor	a
	call	fill
	ld	hl,22528
	ld	c,255
	ld	a,56

; Fill memory block

fill	ld	d,h
	ld	e,l
	inc	de
	ld	(hl),a
	ldir
	ret

; Text writing routine

clrwr	call	clrla
write	ld	a,(ix+1)
	add	a,a
	add	a,a
	add	a,a
	ld	b,a
	ld	a,(ix)
	add	a,a
	add	a,a
	add	a,a
	ld	c,a
	ld	a,b
	call	22b1h
	inc	ix
	inc	ix
	ex	de,hl
wr1	ld	a,(ix)
	cp	32
	jr	c,write
	inc	ix
	cp	'$'
	ret	z
	call	wrchr
	jr	wr1
wrchr	ld	c,0
wrc1	cp	32
	jr	c,wrerr
	cp	128
	jr	c,wrnor
	sub	128
	ld	c,255
	jr	wrc1
wrerr	ld	a,'.'
wrnor	push	bc
	ld	l,a
	ld	h,0
	add	hl,hl
	add	hl,hl
	add	hl,hl
	ld	bc,15360
	add	hl,bc
	pop	bc
	push	de
	ld	b,8
wr2	ld	a,(hl)
	xor	c
	ld	(de),a
	inc	hl
	inc	d
	djnz	wr2
	pop	de
	inc	de
	ret

; Make correct attributes of the last line

attrla	ld	hl,22752
	ld	bc,2001h
	ld	a,120

; Draw an attribute-rectangle

attr	ld	de,32
at1	push	hl
	push	bc
at2	ld	(hl),a
	inc	hl
	djnz	at2
	pop	bc
	pop	hl
	add	hl,de
	dec	c
	jr	nz,at1
	ret

; Print a string

prstr	ld	a,b
	or	c
	ret	z
	dec	bc
	ld	a,(hl)
	inc	hl
	push	hl
	push	bc
	call	wrchr
	pop	bc
	pop	hl
	jr	prstr

; Write a hexadecimal word

hexw	ld	a,h
	call	hexb
	ld	a,l

; Write a hexadecimal byte

hexb	push	af
	rrca
	rrca
	rrca
	rrca
	call	hexn
	pop	af

; Write a hexadecimal nibble

hexn	and	15
	cp	10
	jr	c,hexc
	add	a,7
hexc	add	a,30h
	push	hl
	call	wrchr
	pop	hl
	ret

; Wait the key and get it

keyin	ld	a,(23560)
	or	a
	jr	z,keyin
	ld	(iy-50),0
	ret

; Make some tone

beep	ld	de,50
	ld	hl,1000
	jp	03b5h

; Menu handler

funct	call	keyin
	cp	64
	jp	z,8
	ld	b,a
fu1	ld	a,(hl)
	cp	255
	jp	z,beep
	inc	hl
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	cp	b
	jr	nz,fu1
	push	de
	ret

numbuf	ds	4

; Read some hexadecimal word

inpw	call	write
	ld	hl,numbuf
	ld	b,4
	push	hl
	call	edit
	pop	hl
	ld	b,4
	ld	de,0
scann	ld	a,(hl)
	inc	hl
	cp	32
	jr	z,scfail
	sub	48
	jr	c,sce
	cp	10
	jr	c,sce
	sub	7
sce	and	15
	push	hl
	ld	h,0
	ld	l,a
	ex	de,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,de
	ex	de,hl
	pop	hl
scfail	djnz	scann
	ex	de,hl
	ret

; Read some hexadecimal byte

inpb	call	inpw
	ld	a,l
	ret

; Edit some string

edit	ld	c,0
ed1	push	hl
	push	bc
	ld	a,160
	call	wrchr
	dec	de
	pop	bc
	pop	hl
ed2	call	keyin
	cp	7
	jp	z,error
	cp	13
	jr	nz,ed3
	push	hl
	push	bc
	ld	a,32
	call	wrchr
	pop	bc
	pop	hl
ed2a	ld	a,b
	cp	c
	ret	z
	ld	(hl),32
	inc	hl
	inc	c
	jr	ed2a
ed3	cp	12
	jr	nz,ed4
	ld	a,c
	or	a
	jr	z,ed1
	dec	c
	dec	de
	dec	hl
	push	hl
	push	bc
	ld	a,32
	call	wrchr
	ld	a,32
	call	wrchr
	pop	bc
	pop	hl
	dec	de
	dec	de
	jr	ed1
ed4	ex	af,af'
	ld	a,b
	cp	c
	jr	z,ed1
	ex	af,af'
	ld	(hl),a
	inc	hl
	inc	c
	push	bc
	push	hl
	call	wrchr
	pop	hl
	pop	bc
	jr	ed1

; Clear the last line

clrla	ld	hl,40e0h
	ld	c,8
cla1	push	hl
	ld	b,32
cla2	ld	(hl),0
	inc	hl
	djnz	cla2
	pop	hl
	inc	h
	dec	c
	jr	nz,cla1
	ret

; Write some error message

errw	call	clrwr
err	call	beep
	halt
	halt
	halt
	ld	a,(23560)
	or	a
	jr	z,err
	ld	(iy-50),0
	jp	error

; "SURE" request

aysure	ld	ix,aysm
	call	clrwr
	call	keyin
	cp	'y'
	ret	z
	cp	'z'
	ret	z

; Error return to the main menu

error	ld	sp,5a00h
	ei
	jp	main
aysm	db	0,7
	dm	'Are you sure?$'

; Load some block by non-skipping loader

ldblk	scf
	inc	d
	ex	af,af'
	dec	d
	di
	ld	a,15
	out	(254),a
	call	0562h
	ei
	ret

; Draw a display-window

diw	ld	hl,22528
	ld	bc,2007h
	ld	a,48
	call	attr
	jp	attrla

; Write screen header

name	call	write
nattr	push	de
	ld	hl,22528
	ld	bc,2001h
	ld	a,23
	call	attr
	pop	de
	ret

; QUIT function

quit	call	cls
	call	diw
	ld	ix,qname
	call	name
	ld	ix,qtxt
	call	write
	call	aysure
	rst	0
qname	db	0,0
	dm	'QUIT$'
qtxt	db	0,2
	dm	'This function do'
	dm	'es RESET.$'

newt1	db	14,6
	dm	'                '
	db	14,6,'$'

; NEW function

new	ld	ix,newt1
	call	write
	ld	hl,cname
	ld	b,16
	call	edit
	call	cls
	call	diw
	ld	ix,instnm
	call	name
	ld	ix,insttx
	call	write
	call	wkey
	ld	hl,ctab
	ld	b,8
inst1	push	bc
	push	hl
	call	cls
	call	diw
	pop	hl
	call	fetix
	push	hl
	call	name
	pop	hl
	call	fetix
	push	hl
	call	write
	pop	hl
	call	fetix
	push	hl
	ld	hl,inst2
	push	hl
	jp	(ix)
inst2	pop	hl
	pop	bc
	djnz	inst1
	ret

; LD IX,(HL)+

fetix	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	push	de
	pop	ix
	ret

instnm	db	0,0
	dm	'INSTALL NEW$'

insttx	db	0,1
	dm	'This function provides installa-'
	dm	'tion of memory paging  routines,'
	dm	'but you must know  some informa-'
	dm	'tions about  your memory manage-'
	dm	'ment. All numbers are in hex.$'

wkey	ld	ix,wktx
	call	write
	jp	keyin

wktx	db	0,7
	dm	'Press any key$'

c1n	db	0,0
	dm	'PGNR$'
c2n	db	0,0
	dm	'PGPOS$'
c3n	db	0,0
	dm	'PGLEN$'
c4n	db	0,0
	dm	'MINNR$'
c5n	db	0,0
	dm	'DISNR$'
c6n	db	0,0
	dm	'PORT$'
c7n	db	0,0
	dm	'DON$'
c8n	db	0,0
	dm	'DOFF$'
c1t	db	0,1
	dm	'Number of external memory pages.$'
c2t	db	0,1
	dm	'Where  are  the  pages  swapped.'
	dm	'Enter the  higher  byte  of this'
	dm	'address.$'
c3t	db	0,1
	dm	'Enter  page  size  in kilobytes.'
	dm	'Possible are values 1 to #10 and'
	dm	'#20 kilobytes.$'
c4t	db	0,1
	dm	'Enter  number of the first  page'
	dm	'This may be 0 or 1.$'
c5t	db	0,1
	dm	'Enter numbers of two pages,which'
	dm	'can not be used.If all pages are'
	dm	'usable, enter FF twice.$'
c6t	db	0,1
	dm	'The paging  port. This  may be 8'
	dm	'or 16 bit address.$'
c7t	db	0,1
	dm	'This  value will be ORed  to the'
	dm	'page number  before  sending  to'
	dm	'the port.$'
c8t	db	0,1
	dm	'This value will be sent when the'
	dm	'page must be disconnected.$'

ctab	dw	c1n,c1t,c1r
	dw	c2n,c2t,c2r
	dw	c3n,c3t,c3r
	dw	c4n,c4t,c4r
	dw	c5n,c5t,c5r
	dw	c6n,c6t,c6r
	dw	c7n,c7t,c7r
	dw	c8n,c8t,c8r

inb	call	clrla
	ld	ix,empty
	jp	inpb

c1r	call	inb
	ld	(con1),a
	ret

c2r	call	inb
	ld	(con2),a
	ret

c3r	call	inb
	ld	c,0
	or	a
	jr	z,c3r
	cp	17
	jr	c,c3r1
	cp	32
	jr	nz,c3r
	inc	c
	ld	a,(con1)
	add	a,a
	ld	(con1),a
	ld	a,16
c3r1	add	a,a
	add	a,a
	ld	(con3),a
	ld	a,c
	ld	(divide),a
	ret

c4r	call	inb
	cp	2
	jr	nc,c4r
	ld	(con4),a
	ret

inbc	call	inb
inbc0	cp	255
	ret	z
	ld	b,a
	or	a
	jr	nz,inbc1
	ld	a,(con4)
	ld	a,b
	or	a
	ret	z
inbce	call	clrla
	ld	ix,inbcet
	call	inpb
	jr	inbc0

inbc1	ld	a,(con4)
	or	a
	ld	a,(con1)
	jr	nz,inbc2
	dec	a
inbc2	cp	b
	ld	a,b
	ret	nc
	jr	inbce

inbcet	db	0,7
	dm	'Bad page #, again'
	dm	': #$'

c5r	call	inbc
	ld	(con5a),a
	call	inbc
	ld	(con5b),a
	inc	a
	ret	z
	ld	a,(con5a)
	inc	a
	ret	z
	ld	a,(divide)
	or	a
	ret	z
	call	cls
	call	diw
	ld	ix,warnt
	call	name
	ld	ix,warn1
	call	write
	jr	c5r

warnt	db	0,0
	dm	'*** WARNING ***$'

warn1	db	0,1
	dm	'If the page length is 32KB, only'
	dm	'one page may be disabled.  Enter'
	dm	'the values again.$'

c6r	call	clrla
	ld	ix,empty
	call	inpw
	ld	(con6),hl
	ret

c7r	call	inb
	ld	(con7),a
	ret

c8r	call	inb
	ld	(con8),a
	ret

; Internal constants zone

con1	nop
con2	nop
con3	nop
divide	nop
con4	nop
con5a	db	255
con5b	db	255
con6	dw	0
con7	nop
con8	nop
cname	dm	'Spectrum 48K    '

; INFO command

info	call	cls
	call	diw
	ld	ix,infhd1
	call	name
	ld	ix,inft1
	call	write
	ld	a,(con2)
	ld	h,a
	ld	l,0
	push	hl
	call	hexw
	ld	a,'-'
	call	wrchr
	pop	hl
	push	de
	ex	de,hl
	ld	a,(con3)
	ld	h,a
	ld	l,0
	ld	a,(divide)
	or	a
	jr	z,inf1
	add	hl,hl
inf1	add	hl,de
	dec	hl
	pop	de
	call	hexw
	ld	ix,inft2
	call	write
	ld	a,(con4)
	push	af
	call	hexb
	ld	a,'-'
	call	wrchr
	pop	bc
	ld	a,(divide)
	or	a
	ld	a,(con1)
	jr	z,inf2
	rrca
inf2	add	a,b
	dec	a
	call	hexb
	ld	ix,inft3
	call	write
	ld	hl,(con6)
	call	hexw
	ld	a,','
	call	wrchr
	ld	a,(con7)
	call	hexb
	ld	ix,inftx
	call	wr1
	ld	ix,inft4
	call	write
	ld	hl,(con6)
	call	hexw
	ld	a,','
	call	wrchr
	ld	a,(con8)
	call	hexb
	ld	ix,inft5
	call	write
	ld	hl,(con5a)
	ld	a,h
	cp	l
	jr	nz,inf3
	inc	a
	jr	nz,inf3
	ld	ix,infty
	call	wr1
	jr	inf4
inf3	ld	a,l
	cp	255
	jr	z,inf3a
	call	hexb
	ld	a,h
	inc	a
	jr	z,inf4
	push	hl
	ld	a,','
	call	wrchr
	pop	hl
inf3a	ld	a,h
	call	hexb
inf4	call	wkey
	call	cls
	call	diw
	ld	ix,infhd2
	call	name
	ld	ix,inft1
	call	write
	ld	hl,0c000h
	call	hexw
	ld	a,(con3)
	ld	b,a
	ld	c,0
	add	hl,bc
	dec	hl
	push	hl
	ld	a,'-'
	call	wrchr
	pop	hl
	call	hexw
	ld	ix,inft2
	call	write
	xor	a
	call	hexb
	ld	a,'-'
	call	wrchr
	ld	a,(con1)
	call	hexb
	ld	ix,inft5
	call	write
	ld	hl,(con5a)
	ld	a,h
	cp	l
	jr	nz,inf7
	inc	a
	jr	nz,inf7
	ld	ix,infty
	call	wr1
	jr	inf5
inf7	ld	a,(divide)
	or	a
	jr	z,inf4b
	ld	a,l
	inc	a
	ld	a,h
	jr	z,inf6
	ld	a,l
inf6	rlca
	inc	a
	push	af
	call	hexb
	ld	a,','
	call	wrchr
	pop	af
	inc	a
	call	hexb
	jr	inf5
inf4b	ld	a,l
	cp	255
	jr	z,inf8
	call	hexbz
	ld	a,h
	inc	a
	jr	z,inf5
	push	hl
	ld	a,','
	call	wrchr
	pop	hl
inf8	ld	a,h
	call	hexbz
inf5	ld	ix,inft6
	call	write
	jp	wkey

hexbz	ld	b,a
	ld	a,(con4)
	sub	b
	neg
	inc	a
	jp	hexb

inftx	dm	' OR pg#$'
infty	dm	'NONE$'

infhd1	db	0,0
	dm	'About hardware paging mechanism:$'
infhd2	db	0,0
	dm	'About software paging mechanism:$'
inft1	db	0,1
	dm	'Paged memory zone: $'
inft2	db	0,2
	dm	'Page number: $'
inft3	db	0,4
	dm	'Connect: OUT $'
inft4	db	0,5
	dm	'Disconnect: OUT '
	dm	'$'
inft5	db	0,3
	dm	'Disabled pages: '
	dm	'$'
inft6	db	0,4
	dm	'Entering  0 as  the page  number'
	dm	'connects internal memory.$'

; STANDARD function

std	call	cls
	call	diw
	ld	ix,stdn
	call	name
	ld	ix,stdt
	call	write
std1	call	keyin
	sub	49
	jr	c,std1
	cp	2
	jr	nc,std1
	ld	hl,cfg128
	or	a
	jr	z,stdins
	ld	hl,cfg80
stdins	ld	de,con1
	ld	bc,27
	ldir
	ret

stdn	db	0,0
	dm	'INSTALL STANDARD$'
stdt	db	0,1
	dm	'1) Spectrum 128K'
	db	0,2
	dm	'2) Spectrum 80K'
	db	0,7
	dm	'Choose the configuration:$'

cfg128	db	7,0c0h,40h,0
	db	1,2,5
	dw	7ffdh
	db	10h,10h
	dm	'Spectrum 128K   '

cfg80	db	2,0,40h,1
	db	0,255,255
	dw	00ffh
	db	0,0
	dm	'Spectrum 80K    '

; MAKE function

make	call	cls
	call	diw
	ld	ix,mana
	call	name
	ld	a,(motype)
	and	1
	jr	nz,makey
	ld	ix,nofile
errwr	call	write
	call	keyin
	jp	error

makey	ld	ix,matx
	call	write
	call	aysure
	ld	ix,con1-1
	ld	hl,scont
	ld	a,(con1)
	inc	a
	ld	(hl),a
	inc	hl
	ld	de,(con5a)
	ld	a,d
	cp	255
	jr	nz,no6
	cp	e
	jr	z,no7
	ld	d,e
no6	ld	a,(con4)
	or	a
	jr	z,no4
	dec	d
	dec	e
no4	ld	a,(divide)
	or	a
	jr	z,no5
	ld	a,d
	add	a,a
	ld	d,a
	inc	a
	ld	e,a
no5	inc	d
	inc	e
no7	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	a,(con4)
	rrca
	sbc	a,a
	and	03ch
	ld	(hl),a
	inc	hl
;CON #5 ignored
	inc	hl
	ld	(hl),0e5h
	ld	a,(con2)
	cp	0f0h
	jr	nc,ma6y
	add	a,(ix+3)
	jr	c,ma6y
	ld	b,a
	ld	a,(divide)
	or	a
	ld	a,b
	jr	z,max
	add	a,(ix+3)
	jr	c,ma6y
max	cp	0f0h
	jr	c,ma6n
ma6y	ld	(hl),0d5h
ma6n	inc	hl
	ld	de,(con6)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	a,(divide)
	rrca
	sbc	a,a
	and	0fh
	ld	d,a
	ld	(hl),a
	inc	hl
	ld	a,(con1)
	dec	a
	ld	b,a
	ld	a,255
ma9a	sla	b
	jr	c,ma9b
	srl	a
	jr	ma9a
ma9b	ld	(hl),a
	inc	hl
	ld	a,(con7)
	ld	(hl),a
	inc	hl
	ld	a,(con8)
	ld	(hl),a
	inc	hl
	ld	(hl),d
	inc	hl
	ld	a,(divide)
	rrca
	sbc	a,a
	and	64
	ld	(hl),a
	inc	hl
	ld	a,(con2)
	ld	(hl),a
	inc	hl
	ld	a,0c0h
	add	a,(ix+3)
	jr	z,ma15y
	cp	0f0h
	jr	c,ma15n
ma15y	sub	0f0h
	add	a,48h
ma15n	ld	(hl),a
	call	cls
	call	diw
	ld	ix,sco
	call	name
	ld	hl,scont
	ld	b,16
make1	ld	a,(hl)
	push	bc
	call	hexb
	pop	bc
	inc	hl
	inc	de
	inc	de
	djnz	make1
	ld	hl,cname
	ld	de,modat+33
	ld	bc,16
	ldir
	xor	a
	ld	ix,modat+3
	ld	de,scont
maa1	ex	af,af'
	ld	l,(ix)
	inc	ix
	ld	h,(ix)
	inc	ix
	ld	a,h
	or	l
	jr	z,maa2a
	push	de
	ld	de,(hdr2+13)
	and	a
	sbc	hl,de
	ld	de,modat
	add	hl,de
	pop	de
maa2a	ex	af,af'
maa2	ex	af,af'
	ld	a,(de)
	ld	(hl),a
	inc	de
	inc	hl
	ex	af,af'
	inc	a
	cp	7
	jr	z,maa2
	cp	16
	jr	c,maa1
	ld	a,(motype)
	and	2
	jr	z,masave
maasp	ld	ix,con1
	ld	hl,machk
	push	hl
	ld	hl,(modat+49)
	ld	de,(hdr2+13)
	and	a
	sbc	hl,de
	ld	de,modat
	add	hl,de
	ld	de,(hdr2+13)
	ld	bc,(hdr2+11)
	ld	a,versionid
	jp	(hl)
machk	or	a
	jr	z,masave
	ld	ix,inster
	ld	a,h
	or	l
	jr	z,machk1
	ld	de,(hdr2+13)
	and	a
	sbc	hl,de
	ld	de,modat
	add	hl,de
	push	hl
	pop	ix
machk1	jp	errwr

masave	ld	ix,sttpm
	call	write
	call	keyin
	call	clrla
	ld	a,(motype)
	and	8
	jr	nz,mastos
	ld	a,(motype)
	and	4
	jr	nz,macod
	ld	hl,hdr2+1
	ld	de,header+1
	ld	bc,10
	ldir
	ld	ix,header
	ld	de,17
	xor	a
	call	sblk
	ld	ix,ldrat
	ld	de,ldrlen
	ld	a,255
	call	sblk
macod	ld	ix,hdr2
	ld	de,17
	xor	a
	call	sblk
	ld	ix,modat
	ld	de,(hdr2+11)
	ld	a,255
sblk	call	04c2h
	ld	b,25
sblk1	halt
	djnz	sblk1
	ret

mastos	ld	hl,16384
	ld	de,16385
	ld	bc,116
	ld	(hl),l
	ldir
	ld	de,16384
	ld	hl,hdr2+1
	ld	b,10
mast1	ld	a,(hl)
	ld	(de),a
	inc	hl
	inc	de
	djnz	mast1
	ld	b,6
	ld	a,32
mast2	ld	(de),a
	inc	de
	djnz	mast2
	ld	hl,(hdr2+11)
	ld	(401fh),hl
	ld	hl,(hdr2+13)
	ld	(4019h),hl
	ld	ix,16384
	ld	de,117
	ld	a,1
	call	sblk
	ld	ix,modat
	ld	de,(hdr2+11)
	ld	a,254
	jp	sblk

mana	db	0,0
	dm	'MAKE$'

matx	db	0,1
	dm	'This function saves  on the tape'
	dm	'the completely installed module.$'

sttpm	db	0,7
	dm	'Start tape, then press any key.$'

sco	db	0,0
	dm	'Current definition'
	db	0,2,'$'

scont	ds	16

nofile	db	0,7
	dm	'None module loaded'
	dm	'$'

inster	db	0,7
	dm	'Module installation failed.$'

header	db	0
	dm	'STOS 2.01 '
	dw	ldrlen
	dw	0
	dw	ldrlen

hdr2	db	3
	dm	'MODULENAME'
	dw	100
	dw	16384
	dw	0

motype	db	0

; LOAD function

load	call	cls
	call	diw
	ld	ix,lnam
	call	name
	ld	ix,ltxt
	call	write
	call	aysure
	call	cls
	call	diw
	ld	ix,lnam
	call	name
loadh	ld	ix,hdr2
	ld	de,17
	xor	a
	scf
	call	0556h
	jr	nc,loadh
	ld	ix,foundt
	call	write
	ld	hl,hdr2+1
	ld	bc,10
	call	prstr
	ld	a,(hdr2)
	cp	3
	jr	nz,loadh
	ld	hl,(hdr2+11)
	ld	de,48
	and	a
	sbc	hl,de
	add	hl,de
	jr	c,loadh
	ex	de,hl
	ld	hl,mlmax
	and	a
	sbc	hl,de
	jr	c,ltoolg
	ld	ix,loadt
	call	write
	ld	hl,(hdr2+11)
	call	hexw
	xor	a
	ld	(motype),a
	ld	ix,modat
	ld	de,(hdr2+11)
	ld	a,255
	scf
	call	0556h
	jr	c,recog
	ld	ix,lerr
lerwr	jp	errwr

ltoolg	ld	ix,ltool
	jr	lerwr

recog	ld	a,(modat)
	cp	18h	; STOS?
	jr	nz,recog1
	ld	a,1
	ld	(motype),a
	ret

recog1	or	1
	ld	(motype),a
	ld	a,195
	ld	(modat),a
	ret

lerr	db	0,7
	dm	'Loading error$'

foundt	db	0,2
	dm	'Found file: $'

loadt	db	0,2
	dm	'   Loading: '
	db	6,3
	dm	'Size: $'

ltool	db	0,7
	dm	'Module is too big$'

lnam	db	0,0
	dm	'LOAD MODULE$'

ltxt	db	0,1
	dm	'This  function  loads  from  the'
	dm	'tape  a STOS code module,  which'
	dm	'this program can install.$'

; ### LOADER ###

ldrat
	phase	23755

ldrstart	db	0,0
	dw	lend-line
line	db	249,192
	db	'0',14
	db	0,0
	dw	start
	db	0

start	ld	sp,stosat
	ld	a,7
	ld	(23693),a
	ld	(23624),a
	xor	a
	out	(254),a
	ld	a,255
	ld	(23694),a
	ld	a,254
	call	1601h
	call	0d6bh
	ld	a,254
	call	1601h
	ld	hl,22528
	ld	bc,2008h
	ld	a,48
	call	lattr
	ld	hl,22561
	ld	bc,1e02h
	ld	a,23+64
	call	lattr
	ld	hl,22657
	ld	bc,1e03h
	ld	a,15+64
	call	lattr
	ld	hl,23052
	ld	bc,0701h
	ld	a,15+64
	call	lattr
	ld	de,tx1
	ld	bc,tx2-tx1
	call	203ch
	ld	ix,lheader
	ld	de,17
	xor	a
	scf
	call	0556h
	jr	nc,llerr
	ld	ix,(lheader+13)
	ld	de,(lheader+11)
	ld	a,255
	scf
	call	0556h
	jr	nc,llerr
	ld	hl,23041
	ld	bc,1e01h
	ld	a,15
	call	lattr
	ld	hl,23209
	ld	bc,0d01h
	ld	a,232
	call	lattr
	ld	de,tx2
	ld	bc,tx3-tx2
	call	203ch
	ld	de,stosat+33
	ld	bc,16
	call	203ch
	call	lkeyin
	ld	hl,16384
	ld	de,16385
	ld	bc,6911
	ld	(hl),l
	ldir
	ld	hl,(lheader+13)
	jp	(hl)

lkeyin	ld	(iy-50),0
lkeyin1	ld	a,(23560)
	or	a
	jr	z,lkeyin1
	ret

lattr	push	hl
	push	bc
lattr1	ld	(hl),a
	inc	l
	djnz	lattr1
	pop	bc
	pop	hl
	ld	de,32
	add	hl,de
	dec	c
	jr	nz,lattr
	ret

llerr	ld	hl,23052
	ld	bc,0702h
	ld	a,232
	call	lattr
	ld	de,tx3
	ld	bc,tx4-tx3
	call	203ch
	call	lkeyin
	rst	0

tx1	db	22,1,2
	dm	'Speed Tape '
	dm	'Operating System'
	db	22,2,10
	dm	'VERSION 3.00'
	db	22,4,1
	db	127
	dm	' 1991 MJSoft Syste'
	dm	'm Software'
	db	22,5,3
	dm	'Tomas Zikmund'
	db	22,6,5
	dm	'& Martin Mares'
	db	22,16,12
	dm	'LOADING'
tx2	db	22,21,9
	dm	'PRESS ANY KEY'
	db	22,16,1
	dm	'Installation: '
tx3	db	22,17,13
	dm	'ERROR'
tx4
	db	13
lheader	ds	17
lend

ldrlen	equ	lend-ldrstart
	dephase
