; MJSOFT Speed Tape Operating System version 3.00
; (c) 1989-1991 MJSoft System Software
; Martin Mares & Tomas Zikmund

fpb	equ	5900h

; Configuration header

	org	32768

	jr	st1
	nop
	dw	kk+x1,kk+x2,kk+x3,kk+x4
	dw	0,kk+x6,kk+x7,kk+x8,kk+x9
	dw	kk+x10,kk+x11,kk+x12,kk+x13
	dw	kk+x14,kk+x15
	dm	'NOT INSTALLED   '

; Initializer

stsecond	db	3eh

st1	xor	a
	ex	af,af'
	ld	hl,5c00h
	ld	de,5a00h
	ld	bc,100h
	ldir

stspecial	ld	sp,5a00h
	ld	iy,5c3ah
	ld	hl,5900h
	ld	de,5901h
	ld	bc,116
	ld	(hl),l
	ldir
	ld	a,1
	ld	(fpb+21),a
	di
	call	007ch
localiser	dec	sp
	dec	sp
	pop	de
	ld	hl,exitb-localiser
	add	hl,de
	push	hl
	ld	hl,lram-localiser
	add	hl,de
	ld	de,23552
	ld	b,1
	ldir
	ld	de,22901
	ld	c,75
	ldir
	ex	af,af'
	or	a
	jr	nz,startstos
	ld	de,61440
	ld	bc,4096
exgstos	ld	a,(hl)
	ex	af,af'
	ld	a,(de)
	ex	af,af'
	ld	(de),a
	ex	af,af'
	ld	(hl),a
	inc	hl
	inc	de
	dec	bc
	ld	a,b
	or	c
	jr	nz,exgstos
startstos	pop	hl
	ld	(exitbptr+1),hl
	jp	error

; Exit (command '@' from main menu)

exitb	ld	hl,5a00h
	ld	de,5c00h
	ld	bc,256
	ldir
	rst	8

; System-variables segment

lram	phase	23552

	db	255,0,34,13,255,0,32,247	; KSTATE
	db	13,35,5			; LAST_K,REPDEL,REPPER
m_loaderr	db	0,7
	dm	'Loading error$'
m_pagenr	db	0,7
	dm	'Page number:$'
m_len	db	16,7
	dm	'Len:$'
m_flag	db	0,7
	dm	'Flag:$'
dumpb	dw	5ccbh
	db	205				; FLAGS
buf	db	0,0,0,0
compr	db	0
	db	0				; MODE
m_memreq	db	5,7
	dm	'- $'
pagenr	db	0
	db	7				; BORDCR
m_compr	db	0,7
	dm	'Compressing$'
m_sttpk	db	0,7
	dm	'Start tape, then press any key$'
	db	0,0,0			; FRAMES
m_beg2	db	0,7
	dm	'Block #2 beg.:$'
m_len2	db	0,7
	dm	'Block #2 len.:$'
m_beg3	db	0,7
	dm	'Block #3 beg.:$'
m_len3	db	0,7
	dm	'Block #3 len.:$'
quitmenu	db	0,7
	dm	'Basic Reset Cancel$'
memmenu	db	0,7
	dm	'Addr Next Change Text Find Menu$'
m_ireg	db	0,7
	dm	'I reg.:$'
	dephase

; Screen-data

mem_22901	phase	22901
spdtable	dm	'NORM'
	dm	'DBL '
	dm	'4000'
	dm	'5000'
m_address2	db	23,0
	dm	'Address:'
	db	23,1
	dm	'    '
	db	23,1,'$'
m_start	db	0,7
	dm	'Start:$'
m_length	db	0,7
	dm	'Length:$'
m_loading	db	25,7
	dm	'Loading$'
m_address	db	0,7
	dm	'Address:$'
	dephase

; High-RAM Code

stosstartlow
	org	61440
stosstart

; ### HSAVEd ROUTINES ###

; HSave basic program

bas	db	0,0
	dw	mcs-bas
	db	249,192,'0'
	db	14,0,0
	dw	mcs-bas+5ccbh
	db	0
	db	13

; Startup code in HSave basic program
; Move first all needed routines from correct address

mcs	di
	ld	sp,5a00h
	ld	hl,5c00h
	ld	de,5a00h
	ld	bc,100h
	ldir
	ld	h,0f0h	; ????
	ld	d,48h
	ld	b,10h
	ldir
	ld	hl,mcn-bas+5ccbh
	ld	de,mcn
	push	de
	ld	bc,ldrend-mcn
	ldir
	ret

; OK! We're in upper RAM, we can load and run the program

mcn	ld	ix,fpb
	ld	de,117
	ld	a,1
	scf
	call	0556h
	jp	nc,0
	ld	ix,(fpb+25)
	ld	de,(fpb+31)
	call	xlblk
	ld	ix,(fpb+27)
	ld	de,(fpb+33)
	call	xlblk
	ld	ix,(fpb+29)
	ld	de,(fpb+35)
	call	xlblk
	call	pxr1
; Entry point used by RUN & EXMON commands
run1	ld	hl,xstart
	ld	de,4000h
	push	de
	ld	bc,xstend-xstart
	ldir
	di
	ret

; De-compress program

pxr1	ld	a,(fpb+114)
	ld	hl,(fpb+25)
	ld	bc,(fpb+31)
	call	xxor
	ld	a,(fpb+115)
	ld	hl,(fpb+27)
	ld	bc,(fpb+33)
	call	xxor
	ld	a,(fpb+116)
	ld	hl,(fpb+29)
	ld	bc,(fpb+35)
xxor	ld	d,a
	or	a
	ret	z
xxor1	ld	a,b
	or	c
	ret	z
	call	fetch
	xor	d
	call	store
	inc	hl
	dec	bc
	ld	a,b
	or	c
	jr	nz,xxor1
	ret

; Special block loader used by HSave

xlblk	ld	a,d
	or	e
	ret	z
	ld	a,254
	scf
	ex	af,af'
	call	cntr
	exx
	ld	d,58h
	exx
	di
	call	lrut1
	or	a
	ret	z
	rst	0

; Draw "counter"

cntr	ld	a,d
	rrca
	rrca
	rrca
	and	31
	ld	hl,58e0h
	or	a
cnt1	ret	z
	ld	(hl),87
	inc	hl
	dec	a
	jr	cnt1

; Globally used starter - fetches all parameters from FPB
; Warning: must be on the correct place in VRAM

xstart	ld	a,(fpb+22)
	ld	i,a
	ld	a,(fpb+21)
	dec	a
	jr	z,xst3
	im	2
xst3	ld	a,(fpb+20)
xstmain	ld	hl,4800h
	ld	de,0f000h
	ld	bc,4096
	ldir
	ld	h,5ah
	ld	d,5ch
	ld	b,1
	ldir
	ld	sp,(fpb+16)
	ld	hl,(fpb+18)
	rrca
	jr	nc,xst2
	ei
xst2	jp	(hl)
xstend

; Fetch one byte with respect to skipping

fetch	push	hl
	call	conv
	ld	a,(hl)
	pop	hl
	ret

; Store one byte with respect to skipping

store	push	hl
	push	af
	call	conv
	pop	af
	ld	(hl),a
	pop	hl
	ret

; Recalculate address with respect to skipping

conv	ld	a,h
	cp	5ch
	ret	c
	cp	5dh
	jr	c,csys
	cp	0f0h
	ret	c
	sub	0f0h-48h
	ld	h,a
	ret
csys	sub	2
	ld	h,a
	ret

; Load/Save return

LFED7	ld	hl,2758h
	exx
	ei
	ld	a,00h
	ret	c
	ld	a,7fh
	in	a,(0feh)
	rra
	ld	a,0ffh
	ret

; Load/Save skipping routines - also displays counter

LFFD2	ld	a,d
	rrca
	rrca
	rrca
	and	1fh
	add	0e0h
	exx
	ld	e,a
	ld	a,ixh
	cp	0f0h
	jr	nc,LFFF0
	cp	5ch
	jr	z,LFFF4
	cp	5bh
	jr	nc,LFFF8
	ld	hl,0000h
	jp	LFFFC

LFFF0	sub	0a6h
	ld	h,00h
LFFF4	sub	02h
	ret	z
	inc	bc
LFFF8	ld	h,a
	ld	a,ixl
	ld	l,a
LFFFC	ld	a,78h
	ld	(de),a
	ret

; LOADER

lrut	inc	d
	ex	af,af'
	dec	d
	call	LFF9B
; Secondary entry point used by HSave routines
lrut1	ld	a,0fh
	out	(0feh),a
	ld	hl,LFED7
	push	hl
	in	a,(0feh)
	rra
	and	20h
	or	02h
	ld	c,a
	cp	a
LFEFA	ret	nz
LFEFB	call	LFF7D
	jr	nc,LFEFA
	ld	hl,0415h
LFF03	djnz	LFF03
	dec	hl
	ld	a,h
	or	l
	jr	nz,LFF03
	call	LFF79
	jr	nc,LFEFA
LFF0F	ld	b,9ch
	call	LFF79
	jr	nc,LFEFA
	ld	a,0c6h
	cp	b
	jr	nc,LFEFB
	inc	h
	jr	nz,LFF0F
LFF1E	ld	b,0c9h
	call	LFF7D
	jr	nc,LFEFA
	ld	a,b
LFF27	equ	$+1
	cp	0d4h
	jr	nc,LFF1E
	call	LFF7D
	ret	nc
	ld	a,c
	xor	03h
	ld	c,a
	ld	h,00h
LFF35	equ	$+1
	ld	b,0b0h
	jr	LFF5E

LFF38	ex	af,af'
	jr	nz,LFF49
	jr	nc,LFF53
	push	af
	call	LFFD2
	exx
	ld	a,l
	exx
	ld	(hl),a
	exx
	pop	af
	jr	LFF58

LFF49	rl	c
	xor	l
	ret	nz
	ld	a,c
	rra
	ld	c,a
	inc	de
	jr	LFF5A

LFF53	ld	a,(ix+00h)
	xor	l
	ret	nz
LFF58	inc	ix
LFF5A	dec	de
	ex	af,af'
LFF5D	equ	$+1
	ld	b,0b2h
LFF5E	ld	l,01h
LFF60	call	LFF79
	ret	nc
LFF65	equ	$+1
	ld	a,0cbh
	cp	b
	rl	l
LFF6A	equ	$+1
	ld	b,0b0h
	jp	nc,LFF60
	ld	a,h
	xor	l
	ld	h,a
	ld	a,d
	or	e
	jr	nz,LFF38
	ld	a,h
	cp	01h
	ret

LFF79	call	LFF7D
	ret	nc
LFF7E	equ	$+1
LFF7D	ld	a,16h
LFF7F	dec	a
	jr	nz,LFF7F
	and	a
LFF83	inc	b
	ret	z
	ld	a,7fh
	in	a,(0feh)
	rra
	ret	nc
	xor	c
	and	20h
	jr	z,LFF83
	ld	a,c
	cpl
	ld	c,a
	and	07h
	or	08h
	out	(0feh),a
	scf
	ret
ldrend

; ### END OF HSAVEd BLOCK ###

; Speed constants modifier

LFF9B	di
LFF9C	push	af
	push	ix
	ld	ix,LFFBE
	push	de
	ld	b,0ah
LFFA6	ld	e,(ix+00h)
	inc	ix
	ld	d,(ix+00h)
	inc	ix
	ld	a,(hl)
	inc	hl
	ld	(de),a
	djnz	LFFA6
	pop	de
	pop	ix
	pop	af
	exx
	ld	d,58h
	exx
	ret

; SAVER

srut	call	LFF9B
	ld	hl,LFED7
	push	hl
	ld	hl,1F80H
	bit	7,a
	jr	z,LFE62
	ld	hl,0C98H
LFE62	ex	af,af'
	inc	de
	dec	ix
	ld	a,02h
	ld	b,a
LFE69	djnz	LFE69
	out	(0feh),a
	xor	0fh
	ld	b,0a4h
	dec	l
	jr	nz,LFE69
	dec	b
	dec	h
	jp	p,LFE69
	ld	b,2fh
LFE7B	djnz	LFE7B
	out	(0feh),a
	ld	a,0dh
	ld	b,37h
LFE83	djnz	LFE83
	out	(0feh),a
LFE89	equ	$+2
	ld	bc,3b0eh
	ex	af,af'
	ld	l,a
	jp	LFE9F

LFE8F	ld	a,d
	or	e
	jr	z,LFEA6
	push	af
	call	LFFD2
	ld	a,(hl)
	exx
	ld	l,a
	nop
	nop
	pop	af
LFE9D	ld	a,h
	xor	l
LFE9F	ld	h,a
	ld	a,01h
	scf
	jp	LFEBD

LFEA6	ld	l,h
	jr	LFE9D

LFEA9	ld	a,c
	bit	7,b
LFEAC	djnz	LFEAC
	jr	nc,LFEB4
LFEB1	equ	$+1
	ld	b,42h
LFEB2	djnz	LFEB2
LFEB4	out	(0feh),a
LFEB7	equ	$+1
	ld	b,3eh
	jr	nz,LFEA9
	dec	b
	xor	a
	inc	a
LFEBD	rl	l
	jp	nz,LFEAC
	dec	de
	inc	ix
LFEC6	equ	$+1
	ld	b,31h
	ld	a,7fh
	in	a,(0feh)
	rra
	ret	nc
	ld	a,d
	inc	a
	jp	nz,LFE8F
	ld	b,3bh
LFED4	djnz	LFED4
	ret

; Constant address table

LFFBE	dw	LFE89,LFEB1,LFEB7,LFEC6,LFF27,LFF35,LFF5D,LFF65
	dw	LFF6A,LFF7E

; Clear the screen

cls	ld	hl,16384
	ld	bc,2047
	xor	a
	call	fill
	ld	hl,22528
	ld	c,255
	ld	a,56

; Fill memory block

fill	ld	d,h
	ld	e,l
	inc	de
	ld	(hl),a
	ldir
	ret

; Write some text, IX=text address

loadmsg	ld	ix,m_loading
clrwr	call	clrla
write	ld	a,(ix+1)
	add	a,a
	add	a,a
	add	a,a
	ld	b,a
	ld	a,(ix)
	add	a,a
	add	a,a
	add	a,a
	ld	c,a
	ld	a,b
	call	22b1h
	inc	ix
	inc	ix
	ex	de,hl
wr1	ld	a,(ix)
	cp	32
	jr	c,write
	inc	ix
	cp	'$'
	ret	z
	call	wrchr
	jr	wr1
wrchr	ld	c,0
wrc1	cp	32
	jr	c,wrerr
	cp	128
	jr	c,wrnor
	sub	128
	ld	c,255
	jr	wrc1
wrerr	ld	a,'.'
wrnor	push	bc
	ld	l,a
	ld	h,0
	add	hl,hl
	add	hl,hl
	add	hl,hl
	ld	bc,15360
	add	hl,bc
	pop	bc
	push	de
	ld	b,8
wr2	ld	a,(hl)
	xor	c
	ld	(de),a
	inc	hl
	inc	d
	djnz	wr2
	pop	de
	inc	de
	ret

; Make correct attributes on the last line

attrla	ld	hl,22752
	ld	bc,2001h
	ld	a,120

; Draw an attribute-rectangle

attr	ld	de,32
at1	push	hl
	push	bc
at2	ld	(hl),a
	inc	hl
	djnz	at2
	pop	bc
	pop	hl
	add	hl,de
	dec	c
	jr	nz,at1
	ret

; Display the main menu

maind	call	cls
	ld	ix,maing
	call	write
	ld	hl,22544
	ld	bc,1007h
	ld	a,112
	call	attr
	ld	hl,22560
	ld	bc,0506h
	ld	a,40
	call	attr
	ld	hl,22569
	ld	bc,0306h
	call	attr
	call	attrla
	ld	de,40feh
	ld	a,(pagenr)
	call	hexb
	ld	a,(fpb+24)
	or	a
	ret	z
	ld	ix,unlkg
	call	write
	ld	hl,22720
	ld	bc,0501h
	ld	a,176
	jr	attr

; Main menu texts

maing	db	16,0
	dm	'Load Run'
	db	27,0
	dm	'Hsave'
	db	16,1
	dm	'Save paGe  eXmon'
	db	16,2
	dm	'Exec Bload hloAd'
	db	16,3
	dm	'Data lOck  cVert'
	db	16,4
	dm	'Poke Call'
	db	16,5
	dm	'Name Quit'
	db	16,6
	dm	'seTp Memory'
	db	0,7
	dm	'STOS 3.00 '
	db	127
	dm	' 1991 MJSoft '
	dm	' Page:'
	db	0,1
	dm	'START'
	db	9,1
	dm	'ST2'
	db	0,2
	dm	'LENG.'
	db	9,2
	dm	'LE2'
	db	0,3
	dm	'SP'
	db	9,3
	dm	'ST3'
	db	0,4
	dm	'PC'
	db	9,4
	dm	'LE3'
	db	0,5
	dm	'SPEED'
	db	9,5
	dm	'INT'
	db	0,6
	dm	'PASSW'
	db	9,6
	dm	'IMR'
	db	'$'

unlkg	db	21,3
	dm	'unlOck'
	db	'$'

; Display file parameters

filep	ld	de,4025h
	ld	hl,(fpb+25)
	call	hexw
	ld	de,4045h
	ld	hl,(fpb+31)
	call	hexw
	ld	de,4065h
	ld	hl,(fpb+16)
	call	hexw
	ld	de,4085h
	ld	hl,(fpb+18)
	call	hexw
	ld	de,40c5h
	ld	hl,(passw)
	call	hexw
	ld	de,402ch
	ld	hl,(fpb+27)
	call	hexw
	ld	de,404ch
	ld	hl,(fpb+33)
	call	hexw
	ld	de,406ch
	ld	hl,(fpb+29)
	call	hexw
	ld	de,408ch
	ld	hl,(fpb+35)
	call	hexw
	ld	a,(fpb+23)
	ld	l,a
	ld	h,0
	add	hl,hl
	add	hl,hl
	ld	bc,spdtable
	add	hl,bc
	ld	de,40a5h
	ld	b,4
	call	prstr
	ld	e,0
	ld	hl,fpb
	ld	b,16
	call	prstr
	ld	e,0ach
	ld	a,(fpb+20)
	and	1
	add	a,'D'
	call	wrchr
	ld	a,'I'
	call	wrchr
	ld	e,0cch
	ld	a,(fpb+21)
	add	a,'0'
	call	wrchr
	ld	a,','
	call	wrchr
	ld	a,(fpb+22)
	jp	hexb

; Current password
passw	dw	0

; Print a string

prstr	ld	a,(hl)
	inc	hl
	push	hl
	push	bc
	call	wrchr
	pop	bc
	pop	hl
	djnz	prstr
	ret

; Print a hexadecimal word

hexw	ld	a,h
	call	hexb
	ld	a,l

; Print a hexadecimal byte

hexb	push	af
	rrca
	rrca
	rrca
	rrca
	call	hexn
	pop	af

; Print a hexadecimal nibble

hexn	and	15
	cp	10
	jr	c,hexc
	add	a,7
hexc	add	a,30h
	push	hl
	call	wrchr
	pop	hl
	ret

; Wait the key and read it

keyin	ld	a,(23560)
	or	a
	jr	z,keyin
	ld	(iy-50),0
	ret

; Play some tone

beep	ld	de,50
	ld	hl,1000
	jp	03b5h

; Main menu loop

main	ld	a,(compr)
	or	a
	call	nz,pxr
	call	maind
	call	filep
	ld	hl,mmtab
	call	funct
	jr	main

; Menu selector

funct	call	keyin
	cp	64
exitbptr	jp	z,exitb
	ld	b,a
fu1	ld	a,(hl)
	cp	255
	jp	z,beep
	inc	hl
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	cp	b
	jr	nz,fu1
	push	de
	ret

; Function table for main menu

mmtab	db	'l'
	dw	load
	db	's'
	dw	save
	db	'a'
	dw	hload
	db	'd'
	dw	data
	db	'p'
	dw	poke
	db	'n'
	dw	name
	db	'm'
	dw	mem
	db	'M'
	dw	dirmem
	db	'o'
	dw	lock
	db	'q'
	dw	quit
	db	'r'
	dw	run
	db	'g'
	dw	page
	db	'h'
	dw	hsave
	db	'e'
	dw	exec
	db	'c'
	dw	xcall
	db	'b'
	dw	bload
	db	't'
	dw	setp
	db	'x'
	dw	exmon
	db	'v'
	dw	cvert
	db	255

; Write "Repairing" message

repwr	ld	ix,reptx
	jp	clrwr

; LOCK function

lock	call	repwr
	ld	hl,(fpb+25)
	ld	de,(fpb+31)
	call	exor
	ld	hl,(fpb+27)
	ld	de,(fpb+33)
	call	exor
	ld	hl,(fpb+29)
	ld	de,(fpb+35)
	call	exor
	ld	hl,fpb+24
	ld	a,(hl)
	xor	1
	ld	(hl),a
	jp	clrla

; XOR one block by password

exor	ld	bc,(passw)
ex1	ld	a,d
	or	e
	ret	z
	dec	de
	call	fetch
	xor	c
	call	store
	inc	hl
	ld	a,d
	or	e
	ret	z
	dec	de
	call	fetch
	xor	b
	call	store
	inc	hl
	jr	ex1

; MEMORY menu loop

mem	call	tpassw
	call	ecomp
dirmem	call	cls
	ld	ix,memmenu
	call	write
	call	attrla
	call	dump
	ld	hl,memfn
	call	funct
	jr	mem

; MEMORY menu function table

memfn	db	'a'
	dw	base
	db	'n'
	dw	next
	db	'c'
	dw	chg
	db	't'
	dw	ascii
	db	'f'
	dw	mfind
	db	'm'
	dw	error
	db	255

; NEXT function

next	ld	hl,(dumpb)
	ld	de,24
	add	hl,de
	ld	(dumpb),hl
	ret

; View memory dump

dump	ld	de,16384
	ld	ix,(dumpb)
	ld	b,7
du1	push	de
	push	bc
	push	ix
	pop	hl
	call	hexw
	inc	de
	ld	b,4
	push	ix
du2	push	bc
	push	ix
	push	ix
	pop	hl
	call	fetch
	call	hexb
	inc	de
	pop	ix
	pop	bc
	inc	ix
	djnz	du2
	pop	ix
	inc	de
	ld	b,4
du3	push	bc
	push	ix
	push	ix
	pop	hl
	call	fetch
	call	wrchr
	pop	ix
	pop	bc
	inc	ix
	djnz	du3
	pop	bc
	pop	de
	ld	hl,32
	add	hl,de
	ex	de,hl
	djnz	du1
	ret

; Set dump base - ADDR command

base	ld	ix,m_address2
	call	inpw
	ld	(dumpb),hl
	ret

; Enter some LENGTH

inlen	ld	ix,m_len
	jr	inpw

; Enter some address

inadr	ld	ix,m_address

; Read some hexadecimal word

inpw	call	write
	ld	hl,buf
	ld	b,4
	push	hl
	call	edit
	pop	hl
	ld	b,4
	ld	de,0
scann	ld	a,(hl)
	inc	hl
	cp	32
	jr	z,scfail
	sub	48
	jr	c,sce
	cp	10
	jr	c,sce
	sub	7
sce	and	15
	push	hl
	ld	h,0
	ld	l,a
	ex	de,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,de
	ex	de,hl
	pop	hl
scfail	djnz	scann
	ex	de,hl
	ret

; Read some hexadecimal byte

inpb	call	inpw
	ld	a,l
	ret

; Edit some string

edit	ld	c,0
ed1	push	hl
	push	bc
	ld	a,160
	call	wrchr
	dec	de
	pop	bc
	pop	hl
ed2	call	keyin
	cp	7
	jp	z,error
	cp	13
	jr	nz,ed3
	push	hl
	push	bc
	ld	a,32
	call	wrchr
	pop	bc
	pop	hl
ed2a	ld	a,b
	cp	c
	ret	z
	ld	(hl),32
	inc	hl
	inc	c
	jr	ed2a
ed3	cp	12
	jr	nz,ed4
	ld	a,c
	or	a
	jr	z,ed1
	dec	c
	dec	de
	dec	hl
	push	hl
	push	bc
	ld	a,32
	call	wrchr
	ld	a,32
	call	wrchr
	pop	bc
	pop	hl
	dec	de
	dec	de
	jr	ed1
ed4	ex	af,af'
	ld	a,b
	cp	c
	jr	z,ed1
	ex	af,af'
	ld	(hl),a
	inc	hl
	inc	c
	push	bc
	push	hl
	call	wrchr
	pop	hl
	pop	bc
	jr	ed1

; SETP function

setp	ld	hl,setp1
	push	hl
	jr	pokex

; POKE function

poke	call	tpassw
	call	ecomp
	ld	hl,po0
	push	hl
pokex	call	cls
	ld	hl,fpb+37
	ld	de,16384
	ld	b,7
ps1	push	bc
	push	de
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	inc	hl
	push	hl
	ld	h,b
	ld	l,c
	call	hexw
	inc	de
	pop	hl
	ld	a,(hl)
	inc	hl
	push	hl
	call	hexb
	inc	de
	pop	hl
	ld	b,8
	call	prstr
	pop	de
	pop	bc
	push	hl
	ld	hl,32
	add	hl,de
	ex	de,hl
	pop	hl
	djnz	ps1
	ld	ix,pokeg
	call	write
	call	attrla
po1	call	keyin
	cp	'm'
	jp	z,error
	sub	'1'
	jr	c,po1
	cp	7
	jr	nc,po1
	ld	l,a
	ld	h,0
	ld	b,h
	ld	c,l
	add	hl,hl
	ld	d,h
	ld	e,l
	add	hl,hl
	add	hl,hl
	add	hl,de
	add	hl,bc
	ld	bc,fpb+37
	add	hl,bc
	ret

po0	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	a,(hl)
	push	af
	ex	de,hl
	call	fetch
	ld	(de),a
	pop	af
	call	store
	ld	b,8
pok1	inc	de
	ld	a,(de)
	xor	128
	ld	(de),a
	djnz	pok1
	ret

pokeg	db	0,7
	dm	'Menu 1234567$'

; DATA menu loop

data	call	clrt
	call	ecomp
	ld	ix,datag
	call	write
da3	call	clrla
	ld	hl,datfn
	call	funct
	jr	da3

; DATA menu text

datag	db	16,0
	dm	'Start'
	db	25,0
	dm	'1 st2'
	db	16,1
	dm	'Length'
	db	25,1
	dm	'2 le2'
	db	16,2
	dm	'sP'
	db	25,2
	dm	'3 st3'
	db	16,3
	dm	'pC'
	db	25,3
	dm	'4 le3'
	db	16,4
	dm	'spEed'
	db	25,4
	dm	'Int'
	db	16,5
	dm	'passWord iR'
	db	16,6
	dm	'Menu'
	db	25,6
	dm	'imOde'
	db	'$'

; DATA menu function table

datfn	db	's'
	dw	dstart
	db	'l'
	dw	dleng
	db	'p'
	dw	dsp
	db	'c'
	dw	dpc
	db	'e'
	dw	dspeed
	db	'w'
	dw	dpassw
	db	'm'
	dw	error
	db	'1'
	dw	dst2
	db	'2'
	dw	dle2
	db	'3'
	dw	dst3
	db	'4'
	dw	dle3
	db	'i'
	dw	dint
	db	'r'
	dw	dir
	db	'o'
	dw	dim
	db	255

; Entries for various data items

dstart	ld	hl,fpb+25
	ld	ix,m_start
	jr	dnum

dleng	ld	hl,fpb+31
	ld	ix,m_length
	jr	dnum

dsp	ld	hl,fpb+16
	ld	ix,msp
	jr	dnum

dpc	ld	hl,fpb+18
	ld	ix,mpc
	jr	dnum

dpassw	ld	hl,passw
	ld	ix,mpassw
	jr	dnum

dst2	ld	hl,fpb+27
	ld	ix,m_beg2
	jr	dnum

dle2	ld	hl,fpb+33
	ld	ix,m_len2
	jr	dnum

dst3	ld	hl,fpb+29
	ld	ix,m_beg3
	jr	dnum

dle3	ld	hl,fpb+35
	ld	ix,m_len3

; Evaluation of ONE data item

dnum	push	hl
	call	inpw
	pop	de
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	jp	filep

; Change SPEED

dspeed	ld	hl,fpb+23
	ld	a,(hl)
	inc	a
	and	3
	ld	(hl),a
ifilep	jp	filep

; Change DI/EI

dint	ld	hl,fpb+20
	ld	a,(hl)
	xor	1
	ld	(hl),a
	jr	ifilep

; Change IM

dim	ld	hl,fpb+21
	ld	a,(hl)
	dec	a
	xor	1
	inc	a
	ld	(hl),a
	jr	ifilep

; Change I register

dir	ld	ix,m_ireg
	call	inpb
	ld	(fpb+22),a
	jr	ifilep

; Variuous text

msp	db	0,7
	dm	'Stack:$'
mpc	db	0,7
	dm	'Start PC:$'
mpassw	db	0,7
	dm	'Password:$'

; Clear the last display line

clrla	ld	hl,40e0h
	ld	c,8
cla1	push	hl
	ld	b,32
cla2	ld	(hl),0
	inc	hl
	djnz	cla2
	pop	hl
	inc	h
	dec	c
	jr	nz,cla1
	ret

; Set name

name	call	clrla
	ld	de,16608
	ld	hl,fpb
	ld	b,16
	jp	edit

; Save the file

save	call	cxr
	call	sttpk
hsa1	ld	ix,fpb
	ld	de,117
	ld	a,1
	call	04c6h
	ei
	call	sawt
	ld	ix,(fpb+25)
	ld	de,(fpb+31)
	call	sblk
	ld	ix,(fpb+27)
	ld	de,(fpb+33)
	call	sblk
	ld	ix,(fpb+29)
	ld	de,(fpb+35)
	call	sblk
	call	sawt
	jp	beep

; Save a block

sblk	ld	a,d
	or	e
	ret	z
	call	cntr
	call	speed
	ld	a,254
	call	sblo
sawt	ld	b,25
sw1	halt
	djnz	sw1
	ret

; Save a block - part II

sblo	call	srut
send	push	af
	ex	af,af'
	ld	a,7
	out	(254),a
	pop	af
	or	a
	ret	z
	ex	af,af'
	jr	nc,break
	ld	ix,m_loaderr
	jp	errw

; Display some Break/Error message

break	ld	ix,brm
errw	call	clrwr
err	call	beep
	halt
	halt
	halt
	ld	a,(23560)
	or	a
	jr	z,err
	ld	(iy-50),0
	jp	error

brm	db	0,7
	dm	'Aborted$'

; Find the right set of speed constants

speed	ld	a,(fpb+23)
spd1	ld	l,a
	ld	h,0
	add	hl,hl
	ld	b,h
	ld	c,l
	add	hl,hl
	add	hl,hl
	add	hl,bc
	ld	bc,consts
	add	hl,bc
	ret

; Speed constants table

consts	db	59,66,62,49,212
	db	176,178,203,176,22
	db	31,38,34,21,214
	db	210,211,224,210,13
	db	16,23,19,6,216
	db	228,229,235,228,7
	db	12,19,15,2,217
	db	233,234,240,233,3

; Load a file

load	ld	ix,lom
	call	clrwr
	ld	ix,fpb
	ld	de,117
	ld	a,1
	call	ldblk
	jp	nc,break
	call	clrla
	call	filep
	call	loadmsg
	ld	a,255
	ld	(compr),a
	ld	ix,(fpb+25)
	ld	de,(fpb+31)
	call	lblk
	ld	ix,(fpb+27)
	ld	de,(fpb+33)
	call	lblk
	ld	ix,(fpb+29)
	ld	de,(fpb+35)
	jp	lblk

; Load some block

lblk	ld	a,d
	or	e
	ret	z
	call	cntr
	call	speed
	ld	a,254
	scf
lblo	call	lrut
	jp	send

lom	db	0,7
	dm	'Searching$'

; CALL command

xcall	call	clrla
	call	ecomp
	call	inadr
	ld	a,h
	or	l
	jr	nz,xcall1
	ld	hl,(fpb+18)
xcall1	push	hl
	jp	aysure

aysm	db	0,7
	dm	'Are you sure?$'

; Test file locking

tpassw	ld	a,(fpb+24)
	or	a
	ret	z
	ld	ix,tpaser
	jp	errw

tpaser	db	0,7
	dm	'Locked$'

; RUN command

run	call	tpassw
	call	aysure
	jp	run1

; SETP command - continued

setp1	push	hl
	call	clrla
	call	inadr
	pop	de
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	push	hl
	ld	ix,testp2
	call	inpb
	pop	hl
	ld	(hl),a
	inc	hl
	push	hl
	call	clrla
	ld	ix,testp3
	call	write
	pop	hl
	ld	de,16613
	ld	b,8
	jp	edit

testp2	db	13,7
	dm	'Val:$'
testp3	db	0,7
	dm	'Name:$'

; "SURE" request

aysure	ld	ix,aysm
	call	clrwr
	call	keyin
	cp	'y'
	ret	z
error	ld	sp,5a00h
	ei
	jp	main

; BLOAD command

bload	call	clrla
	call	ecomp
	ld	ix,m_start
	call	inpw
	push	hl
	call	inlen
	push	hl
	push	hl
	call	clrla
	ld	ix,m_flag
	call	inpb
	pop	de
	push	af
	call	cntr
	call	loadmsg
	xor	a
	call	spd1
	pop	af
	pop	de
	pop	ix
	scf
	jp	lblo

; CHANGE command in MEMORY menu

chg	ld	hl,(dumpb)
	ld	b,12
chg1	push	bc
	push	hl
	call	clrla
	call	dump
	pop	hl
	push	hl
	ld	de,16608
	call	hexw
	ld	ix,m_memreq
	call	inpb
	pop	hl
	push	hl
	ld	c,a
	call	conv
	ld	(hl),c
	pop	hl
	inc	hl
	pop	bc
	djnz	chg1
	ld	(dumpb),hl
	jr	chg

; CHANGE ASCII command in MEMORY menu

ascii	ld	hl,(dumpb)
	ld	b,28
asc1	push	bc
	push	hl
	call	clrla
	call	dump
	pop	hl
	push	hl
	ld	de,16608
	call	hexw
	ld	ix,teasc1
	call	write
	pop	hl
	push	hl
	call	conv
	ld	de,16615
	ld	b,1
	call	edit
	pop	hl
	pop	bc
	inc	hl
	djnz	asc1
	ld	(dumpb),hl
	jr	ascii

teasc1	db	4,7
	dm	' - $'

; QUIT command

quit	ld	ix,quitmenu
	call	clrwr
quit1	ld	hl,qfnc
	call	funct
	jr	quit1
qfnc	db	'r'
	dw	reset
	db	'c'
	dw	error
	db	'b'
	dw	basic
	db	255

reset	call	aysure
	rst	0

; Return to BASIC

basic	call	aysure
	di
	ld	sp,4800h
	ld	hl,basrt
	ld	de,5800h
	push	de
	ld	bc,comp-basrt
	ldir
	ret

basrt	ld	hl,4800h
	ld	de,0f000h
	ld	bc,1000h
	ldir
	ld	h,5ah
	ld	d,5ch
	ld	b,1
	ldir
	ld	hl,(23613)
	ld	(hl),3
	inc	hl
	ld	(hl),13h
	ld	a,2
	ld	(23659),a
	im	1
	ei
	rst	8
	db	255

; COMPRESSOR

comp	ld	a,b
	or	c
	ret	z
	exx
	ld	bc,8000h
	exx
compas	push	hl
	push	bc
	ld	de,32768
combyt	call	fetch
	inc	hl
	exx
	and	b
	exx
	jr	z,comzer
	inc	de
	jr	comtst
comzer	dec	de
comtst	ld	a,d
	or	a
	jr	nz,comnxt
	cpl
	jr	comws
comnxt	dec	bc
	ld	a,b
	or	c
	jr	nz,combyt
	ld	a,d
comws	or	a
	exx
	jp	p,comwz
comwo	ld	a,b
	or	c
	ld	c,a
comwz	rrc	b
	ld	a,c
	exx
	pop	bc
	pop	hl
	jr	nc,compas
	ret

; Compress whole file

cxr	ld	hl,fpb+20
	bit	1,(hl)
	jr	z,pxr
	res	1,(hl)
	ld	ix,m_compr
	call	clrwr
	ld	hl,(fpb+25)
	ld	bc,(fpb+31)
	call	comp
	ld	(fpb+114),a
	ld	hl,(fpb+27)
	ld	bc,(fpb+33)
	call	comp
	ld	(fpb+115),a
	ld	hl,(fpb+29)
	ld	bc,(fpb+35)
	call	comp
	ld	(fpb+116),a

; XOR file by compression constants

pxr	ld	ix,reptx
	call	clrwr
	ld	a,(compr)
	cpl
	ld	(compr),a
	ld	hl,clrla
	push	hl
	jp	pxr1

; EXEC command

exec	call	tpassw
	call	page0
	call	49152
	xor	a
	call	page1
	jp	error

; PAGE command

page	ld	hl,error
	push	hl
page0	call	ecomp
	call	clrla
	ld	ix,m_pagenr
	call	inpb
	ld	ix,pgetx
x1	equ	$+1
	cp	0
; For Spectrum 128K config repair constant ^^^ to 8
	jp	nc,errw
x2	equ	$+1
	cp	2
	jr	z,pgerr
x3	equ	$+1
	cp	5
pgerr	jp	z,errw
page1	di
	ld	hl,pagenr
	ld	c,(hl)
	ld	(hl),a
	ld	a,c
	call	exchgp
	ld	a,(pagenr)
exchgp	or	a
	ret	z
	dec	a
	ld	hl,exgp1
	ld	de,16384
	ld	bc,exgpe-exgp1
x6	push	de
	ldir
	ret
x7	equ	$+1
exgp1	ld	bc,32765
x8	nop
	push	af
x9	equ	$+1
	and	7
x4	inc	a
x10	equ	$+1
	or	16
	ld	d,a
x11	equ	$+1
	ld	e,16
	pop	af
x12	nop
x13	equ	$+1
	and	0
x14	equ	$+1
	add	a,0c0h
	ld	h,a
	ld	l,0
	exx
	ld	hl,0c000h
exgp2	ld	a,(hl)
	exx
	out	(c),d
	ex	af,af'
	ld	a,(hl)
	ex	af,af'
	ld	(hl),a
	ex	af,af'
	out	(c),e
	inc	hl
	exx
	ld	(hl),a
	inc	hl
	ld	a,h
x15	equ	$+1
	cp	58h
	ret	z
	cp	0f0h
	jr	nz,exgp2
	ld	h,48h
	jr	exgp2
exgpe

pgetx	db	0,7
	dm	'Bad page number$'
reptx	db	0,7
	dm	'Repairing$'

; Start tape... message

sttpk	ld	ix,m_sttpk
	call	clrwr
	call	keyin
	jp	clrla

; HSAVE command

hsave	call	tpassw
	call	cxr
	call	speed
	call	LFF9C
	call	sttpk

	ld	hl,fpb
	ld	de,hname
	ld	bc,10
	ldir
	ld	ix,header
	ld	de,17
	xor	a
	call	04c6h
	ei
	call	sawt
	ld	ix,bas
	ld	de,ldrend-bas
	ld	a,255
	call	04c6h
	ei
	call	sawt
	jp	hsa1

; HSave BASIC HEADER

header	db	0
hname	ds	10
	dw	ldrend-bas
	dw	0
	dw	ldrend-bas

; Load some block by non-skipping loader

ldblk	scf
	inc	d
	ex	af,af'
	dec	d
	di
	ld	a,15
	out	(254),a
	call	0562h
	ei
	ret

; Clear main menu

clrt	ld	bc,0af80h
clrt1	push	bc
	call	22aah
	ld	b,16
clrt2	ld	(hl),0
	inc	l
	djnz	clrt2
	pop	bc
	dec	b
	ld	a,b
	cp	112
	jr	nz,clrt1
	ret

; FIND function

mfind	call	clrla
	call	inadr
	push	hl
	call	inlen
	push	hl
	call	clrla
	ld	ix,mwhat
	call	inpw
	push	hl
	call	clrla
	pop	de
	pop	bc
	pop	hl
mfi1	call	fetch
	cp	e
	jr	nz,mfifa
	inc	hl
	call	fetch
	dec	hl
	cp	d
	jr	nz,mfifa
	push	hl
	push	de
	push	bc
	ld	de,16608
	call	hexw
	call	keyin
	cp	7
	jp	z,error
	pop	bc
	pop	de
	pop	hl
mfifa	inc	hl
	dec	bc
	ld	a,b
	or	c
	jr	nz,mfi1
	ret

mwhat	db	0,7
	dm	'Find:$'

; HLOAD function

hload	ld	ix,lom
	call	clrwr
	ld	ix,16384
	ld	de,17
	xor	a
	call	ldblk
	jp	nc,break
	ld	a,(16384)
	cp	4
	jr	c,hlo1
	ld	a,4
hlo1	ld	l,a
	add	a,a
	add	a,a
	add	a,l
	ld	l,a
	ld	h,0
	ld	de,hlotab
	add	hl,de
	ld	de,fpb
	ld	bc,5
	ldir
	ld	a,':'
	ld	(de),a
	inc	de
	ld	hl,16385
	ld	c,10
	ldir
	ld	hl,(16384+11)
	ld	(fpb+31),hl
	ld	hl,(16384+13)
	ld	(fpb+25),hl
	ld	hl,(16384+15)
	ld	(fpb+27),hl
	jp	beep

hlotab	dm	'Basic'
	dm	'N.ar.'
	dm	'C.ar.'
	dm	'Bytes'

; EXMON function

exmon	call	tpassw
	call	aysure
	ld	hl,xstart
	ld	(hl),18h
	inc	hl
	ld	(hl),xstmain-xstart-2
	ld	hl,5a80h
	ld	(fpb+16),hl
	dec	h
	ld	(fpb+18),hl
	ex	de,hl
	ld	hl,exmon1
	ld	bc,exmon2-exmon1
	ldir
	xor	a
	jp	run1

exmon1	ld	ix,16384
	ld	de,1900h
	ld	a,255
	scf
	inc	d
	ex	af,af'
	dec	d
	ld	a,15
	out	(254),a
	call	0562h
	jr	nc,exmon1
	jp	4000h
exmon2

; Signal "Compression needed!"

ecomp	ld	a,(fpb+20)
	or	2
	ld	(fpb+20),a
	ret

; CONVERT function

cvert	ld	ix,cvmsg
	call	clrwr
	ld	hl,16384
	push	hl
	ld	b,5
	call	edit
	pop	de
	ld	hl,0
	ld	b,5
cve1	ld	a,(de)
	inc	de
	cp	32
	jr	z,cveend
	sub	'0'
	push	de
	ld	d,h
	ld	e,l
	add	hl,hl
	add	hl,hl
	add	hl,de
	add	hl,hl
	ld	d,0
	ld	e,a
	add	hl,de
	pop	de
	djnz	cve1
cveend	ld	de,40f0h
	call	hexw
	jp	keyin
cvmsg	db	0,7
	dm	'Decimal: $'

stosend

kk	equ	stosstartlow-stosstart
