; STOS MONITOR MODULE 2.01
;(c) 1991 MJSoft System Software
;Martin Mares & Tomas Zikmund

	phase	49152

; ### MODULE HEADER ###

start	db	0eh
	dw	entry
	dw	x1,x2,x3,x4,x5
	dw	x6,x7,x8,x9,x10
	dw	x11,x12,x13,x14,x15
	dm	'Spectrum 128K   '
	dw	instal
	dw	0,0,0

	dm	'MON'
	dw	data

; ### CONNECT A PAGE ###
; HL=entry routine

pgcon	ld	sp,5b00h
	push	hl
upper1	equ	$+1
	ld	a,0
	or	a
	push	af
	jr	nz,pgcon2
	ld	hl,pgcon0
	ld	de,5000h
	ld	bc,pgcone-pgcon0
	push	de
	ldir
	ret
pgcon2	ld	hl,0c000h
	ld	de,5000h
	ld	bc,0800h
	ldir
	ld	hl,pgcona
	ld	de,5a00h
	pop	af
	push	de
	push	af
	ld	bc,pgconb-pgcona
	ldir
pport1	equ	$+1
pgcon0	ld	bc,0
padr1	equ	$+1
	ld	hl,0
pcon1	equ	$+1
	ld	de,0
	exx
	ld	hl,0c000h
	pop	af
	push	af
	jr	z,pgcon1
	ld	h,50h
pgcon1	ld	a,(hl)
	exx
	out	(c),d
	ex	af,af'
	ld	a,(hl)
	ex	af,af'
	ld	(hl),a
	ex	af,af'
	out	(c),e
	inc	hl
	exx
	ld	(hl),a
	inc	hl
	ld	a,h
stop1	equ	$+1
	cp	00h
	jr	z,pgcon3
	cp	58h
	jr	nz,pgcon1
	pop	af
	push	af
	jr	z,pgcon1
	ld	h,0c8h
	jr	pgcon1
pgcon3	pop	af
	ret
pgcone

pgcona	ld	hl,5000h
	ld	de,0c000h
	ld	bc,800h
	ldir
	ret
pgconb

; ### RESTORE: INIT ###

rinit	ld	sp,0c004h
	push	de
	push	hl
	ex	af,af'
	ld	(0c004h),a
rinitn	ld	sp,5b00h
upper3	equ	$+1
	ld	a,0
padr2	equ	$+1
	ld	de,0
	or	a
	jr	z,rini1a
	ld	hl,mystk-start
	add	hl,de
	ld	sp,hl
rini1a	push	af
	or	a
	jr	nz,rinit1

	ld	hl,pgdis-start
	add	hl,de
	ld	de,5000h
	ld	bc,pgdend-pgdis
	push	de
	ldir
	ret

rinit1	push	de
	push	de
	pop	bc
	ld	hl,data+1200h-start
	add	hl,bc
	ex	de,hl
	ld	hl,rinit2-start
	add	hl,bc
	ld	bc,rinit3-rinit2
	push	de
	ldir
	ret

rinit2	pop	hl
	ld	de,0c000h
	ld	bc,0800h
rinit4	ld	a,(hl)
	ex	af,af'
	ld	a,(de)
	ex	af,af'
	ld	(de),a
	ex	af,af'
	ld	(hl),a
	inc	hl
	inc	de
	dec	bc
	ld	a,b
	or	c
	jr	nz,rinit4
	jp	pgdis
rinit3

; ### DISCONNECT A PAGE ###

pport4	equ	$+1
pgdis	ld	bc,0
	pop	af
pcon2	equ	$+1
	ld	de,0
	out	(c),e
padr3	equ	$+1
	ld	hl,0c000h
	exx
psecadr	equ	$+1
	ld	hl,0c000h
	or	a
	jr	z,pgdis1
	ld	h,0c8h
	exx
	ld	a,8
	add	a,h
	ld	h,a
	exx
pgdis1	ld	a,(hl)
	exx
	out	(c),d
	ex	af,af'
	ld	a,(hl)
	ex	af,af'
	ld	(hl),a
	ex	af,af'
	out	(c),e
	inc	hl
	exx
	ld	(hl),a
	inc	hl
	ld	a,h
stop2	equ	$+1
	cp	00h
	jr	nz,pgdis1
	jp	restor
pgdend

; ### ENTRY POINT ###
;(backup STOS & start MONITOR)

entry	ld	(stossp),sp
	ld	sp,mystk
	ld	a,(23623)
	dec	a
	call	compag
	di

	ld	hl,0f000h
	ld	de,4800h
	ld	bc,1000h
	call	exg
	ld	hl,4800h
	ld	de,data
	ld	bc,1000h
	call	exg
	ld	hl,4800h
	ld	de,4000h
	ld	bc,1000h
	ldir
	ld	hl,5c00h
	ld	de,data+1000h
	ld	bc,0100h
	call	exg
	ld	hl,5c00h
	ld	de,5a00h
	ld	bc,0100h
	call	exg
	ld	hl,5a00h
	ld	de,5800h
	ld	bc,0100h
	ldir
	ld	hl,5900h
	ld	de,data+1100h
	ld	bc,0100h
	call	exg

	ld	de,47dah
upper2	equ	$+1
	ld	a,0
	or	a
	jr	nz,patch1
	ld	hl,patch2
	ld	bc,patch3-patch2
	jr	patch5
patch1	ld	hl,patch3
	ld	bc,patch4-patch3
patch5	ldir

	ld	hl,4000h
	jp	pgcon

; ### MONITOR PATCHES ###

pport2	equ	$+1
patch2	ld	bc,32765
pconn1	equ	$+1
	ld	a,17
	out	(c),a
pspec1	equ	$+1
	jp	0

patch3	ld	sp,0c000h
	pop	hl
	pop	de
pspecl	equ	$+2
	ld	bc,000c3h
	push	bc
	ld	bc,079edh
	push	bc
	ld	a,(0c004h)
	ex	af,af'
pspech	equ	$+1
	ld	a,0
	ld	(0c004h),a
pport3	equ	$+1
	ld	bc,32765
pconn2	equ	$+1
	ld	a,17
	jp	0c000h
patch4

; Exchange memory block subr.

exg	ld	a,(hl)
	ex	af,af'
	ld	a,(de)
	ex	af,af'
	ld	(de),a
	ex	af,af'
	ld	(hl),a
	inc	hl
	inc	de
	dec	bc
	ld	a,b
	or	c
	jr	nz,exg
	ret

; ### INSTALLATION ROUTINE ###

instal	ld	a,(ix+2)
	cp	20h
	ld	a,0
	ret	nc
	ld	hl,error1
	ld	a,1
	ret

error1	db	0,7
	dm	'Page too small!!!$'

; ### COMPUTE PAGE CONSTANTS ###
compag
x1	equ	0
x2	equ	0
x3	equ	0
x5	equ	0
x7	equ	$+1
	ld	bc,32765
x8	nop
	push	af
x9	equ	$+1
	and	7
x4	inc	a
x10	equ	$+1
	or	16
	ld	d,a
x11	equ	$+1
	ld	e,16
	pop	af
x12	nop
x13	equ	$+1
	and	0
x14	equ	$+1
	add	a,0c0h
	ld	h,a
	ld	l,0

	ld	(pport1),bc
	ld	(pport2),bc
	ld	(pport3),bc
	ld	(pport4),bc
	ld	(padr1),hl
	ld	(padr2),hl
	push	hl
	ld	(pcon1),de
	ld	(pcon2),de
	ld	a,d
	ld	(pconn2),a
	ld	(pconn1),a

	ex	de,hl
	ld	hl,rinit-start
	add	hl,de
	ld	a,h
	ld	(pspech),a
	ld	a,l
	ld	(pspecl),a

	ld	hl,rinitn-start
	add	hl,de
	ld	(pspec1),hl

	ld	b,0
x6	equ	$+1
	ld	a,0d5h
	cp	0d5h
	jr	z,compg1
	inc	b
compg1	ld	a,b
	ld	(upper1),a
	ld	(upper2),a
	ld	(upper3),a
	ld	(upper4),a

	pop	hl
	ld	de,0c000h
	or	a
	jr	z,compga
	ld	a,h
	add	a,8
	ld	h,a
	ld	a,d
	add	a,8
	ld	d,a
compga	ld	(padr3),hl
	ld	(psecadr),de

x15	equ	$+1
	ld	a,0
	cp	0c0h
	jr	nc,compg2
	add	a,0f0h-48h
compg2	ld	(stop1),a
	ld	(stop2),a
	ret

; ### RESTORE STOS ###

restor	ld	sp,mystk

	ld	hl,4000h
	ld	de,data
	ld	bc,1000h
	call	exg
	ld	hl,4000h
	ld	de,4800h
	ld	bc,0800h
	call	exg
	ld	hl,4000h
	ld	de,5000h
	ld	bc,0800h
	call	exg

	ld	hl,5800h
	ld	de,data+1000h
	ld	bc,0200h
	call	exg
	ld	hl,5800h
	ld	de,5c00h
	ld	bc,0100h
	call	exg
	ld	hl,5800h
	ld	de,5a00h
	ld	bc,0100h
	call	exg

	ld	hl,4800h
	ld	de,0f000h
	ld	bc,1000h
	call	exg

	ld	iy,5c3ah
	ld	sp,(stossp)
upper4	equ	$+1
	ld	a,0
	or	a
	jr	z,rest1
	ld	hl,rest2
	ld	de,5800h
	ld	bc,rest3-rest2
	push	de
	ldir
	ret
rest1	ei
	ret

rest2	ld	hl,4000h
	ld	de,0c000h
	ld	bc,0800h
	ldir
	ei
	ret
rest3

; ### VARIABLES ###

stossp	dw	0

; ### STACK ###

	ds	32
mystk

; ### DATA ###
data

;	incbin	"/various/moncode"
	dephase
